Index: pjproject/trunk/pjlib/include/pj/doxygen.h
===================================================================
--- pjproject/trunk/pjlib/include/pj/doxygen.h	(revision 735)
+++ pjproject/trunk/pjlib/include/pj/doxygen.h	(revision 736)
@@ -56,5 +56,5 @@
  * @subsection doc_ver_subsec Version
  *
- * This document corresponds to PJLIB version 0.5.7.6.
+ * This document corresponds to PJLIB version 0.5.8.
  *
  *
@@ -457,4 +457,12 @@
  *
  * @section build_sys_install_sec Build and Installation
+ *
+ * \note
+ * <b>The most up-to-date information on building and installing PJLIB
+ *  should be found in the website, under "Getting Started" document.
+ *  More over, the new PJLIB build system is now based on autoconf,
+ *  so some of the information here might not be relevant anymore 
+ *  (although most still are, since the autoconf script still use
+ *  the old Makefile system as the backend).</b>
  *
  * @subsection build_sys_install_win32_sec Visual Studio
@@ -794,4 +802,11 @@
  * @page porting_pjlib_pg Porting PJLIB
  *
+ * \note
+ * <b>Since version 0.5.8, PJLIB build system is now based on autoconf, so
+ * most of the time we shouldn't need to apply the tweakings below to get
+ * PJLIB working on a new platform. However, since the autoconf build system
+ * still uses the old Makefile build system, the information below may still
+ * be useful for reference.
+ * </b>
  *
  * @section new_arch_sec Porting to New CPU Architecture
Index: pjproject/trunk/pjlib/include/pj/pool.h
===================================================================
--- pjproject/trunk/pjlib/include/pj/pool.h	(revision 735)
+++ pjproject/trunk/pjlib/include/pj/pool.h	(revision 736)
@@ -102,5 +102,6 @@
  * memory allocation strategy that can speed-up the memory allocations
  * and deallocations by up to <b>30 times</b> compared to standard
- * malloc()/free()!
+ * malloc()/free() (more than 150 million allocations per second on a
+ * P4/3.0GHz Linux machine).
  *
  * (Note: your mileage may vary, of course. You can see how much PJLIB's
Index: pjproject/trunk/pjmedia/include/pjmedia/doxygen.h
===================================================================
--- pjproject/trunk/pjmedia/include/pjmedia/doxygen.h	(revision 735)
+++ pjproject/trunk/pjmedia/include/pjmedia/doxygen.h	(revision 736)
@@ -493,4 +493,13 @@
     Screenshots on WinXP: \image html siprtp.jpg "siprtp screenshot on WinXP"
 
+  - @ref page_pjmedia_samples_tonegen_c\n
+    This is a simple program to generate a tone and write the samples to
+    a raw PCM file. The main purpose of this file is to analyze the
+    quality of the tones/sine wave generated by PJMEDIA tone/sine wave
+    generator.
+
+  - @ref page_pjmedia_samples_aectest_c\n
+    Play a file to speaker, run AEC, and record the microphone input
+    to see if echo is coming.
  */
 
Index: pjproject/trunk/pjsip-apps/src/samples/tonegen.c
===================================================================
--- pjproject/trunk/pjsip-apps/src/samples/tonegen.c	(revision 735)
+++ pjproject/trunk/pjsip-apps/src/samples/tonegen.c	(revision 736)
@@ -17,4 +17,19 @@
  * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
  */
+
+/**
+ * \page page_pjmedia_samples_tonegen_c Samples: Sine Wave/Dual-Tone Generation
+ *
+ * This is a simple program to generate a tone and write the samples to
+ * a raw PCM file. The main purpose of this file is to analyze the
+ * quality of the tones/sine wave generated by PJMEDIA tone/sine wave
+ * generator.
+ *
+ * This file is pjsip-apps/src/samples/tonegen.c
+ *
+ * \includelineno tonegen.c
+ */
+
+
 #include <pjmedia.h>
 #include <pjlib.h>
Index: pjproject/trunk/pjsip/docs/doxygen.h
===================================================================
--- pjproject/trunk/pjsip/docs/doxygen.h	(revision 735)
+++ pjproject/trunk/pjsip/docs/doxygen.h	(revision 736)
@@ -29,6 +29,7 @@
 
 /**
-
-  @mainpage PJSIP
+  \n
+
+  @mainpage PJSIP - Open Source SIP Stack
 
   \n
@@ -119,5 +120,5 @@
   @subsection doc_ver Version
 
-  This document corresponds to PJSIP version 0.5.6.
+  This document corresponds to PJSIP version 0.5.8.
 
   \n
@@ -217,4 +218,10 @@
     Screenshots on WinXP: \image html siprtp.jpg "siprtp screenshot on WinXP"
 
+  - @ref page_pjsip_perf_c\n
+    This sample contains a complete implementation of a SIP performance
+    measurement tool. Unlike other tool such SIPp, pjsip-perf is geared
+    more towards finding the performance of an endpoint by flooding the
+    endpoint with some requests and time the completion of the requests.\n
+    Screenshots on Linux console: \image html pjsip-perf.jpg "pjsip-perf screenshot on Linux"
  */
 
@@ -255,5 +262,5 @@
 
 /**
- * \page page_pjmedia_samples_siprtp_c Samples: Using SIP and Custom RTP/RTCP to Monitor Quality
+ * \page page_pjmedia_samples_siprtp_c Samples: siprtp - SIP with RTCP Quality Monitoring
  *
  * This source is an example to demonstrate using SIP and RTP/RTCP framework
@@ -275,2 +282,17 @@
  */
 
+/**
+ * \page page_pjsip_perf_c Samples: pjsip-perf - SIP Performance Benchmarking Tool
+ *
+ * This sample contains a complete implementation of a SIP performance
+ * measurement tool. Unlike other tool such SIPp, pjsip-perf is geared
+ * more towards finding the performance of an endpoint by flooding the
+ * endpoint with some requests and time the completion of the requests.
+ *
+ * The source code of the file is pjsip-apps/src/samples/pjsip-perf.c
+ *
+ * Screenshots on Linux console: \image html pjsip-perf.jpg
+ *
+ * \includelineno pjsip-perf.c
+ */
+
Index: pjproject/trunk/pjsip/include/pjsip/sip_endpoint.h
===================================================================
--- pjproject/trunk/pjsip/include/pjsip/sip_endpoint.h	(revision 735)
+++ pjproject/trunk/pjsip/include/pjsip/sip_endpoint.h	(revision 736)
@@ -245,7 +245,5 @@
 /**
  * Register the transaction to the endpoint's transaction table.
- * Before the transaction is registered, it must have been initialized as
- * either UAS or UAC by calling #pjsip_tsx_init_uac or #pjsip_tsx_init_uas.
- * This function, like all other endpoint functions, is thread safe.
+ * This function should only be used internally by the stack.
  *
  * @param endpt	    The SIP endpoint.
@@ -256,9 +254,6 @@
 
 /**
- * Forcefull destroy the transaction.
- * The only time where application needs to call this function is when the
- * transaction fails to initialize in #pjsip_tsx_init_uac or
- * #pjsip_tsx_init_uas. For other cases. the transaction will be destroyed
- * automaticly by endpoint.
+ * Forcefull destroy the transaction. This function should only be used
+ * internally by the stack.
  *
  * @param endpt	    The endpoint.
Index: pjproject/trunk/pjsip/include/pjsip/sip_msg.h
===================================================================
--- pjproject/trunk/pjsip/include/pjsip/sip_msg.h	(revision 735)
+++ pjproject/trunk/pjsip/include/pjsip/sip_msg.h	(revision 736)
@@ -911,5 +911,5 @@
  * as argument to a function which will copy the header).
  *
- * @param pool	    The pool.
+ * @param h	    The header to be initialized.
  * @param hname	    The header name to be assigned to the header, or NULL to
  *		    assign the header name with some string.
Index: pjproject/trunk/pjsip/include/pjsip/sip_transport.h
===================================================================
--- pjproject/trunk/pjsip/include/pjsip/sip_transport.h	(revision 735)
+++ pjproject/trunk/pjsip/include/pjsip/sip_transport.h	(revision 736)
@@ -361,5 +361,5 @@
  *
  * A transaction object normally will add reference counter to this buffer
- * when application calls #pjsip_tsx_on_tx_msg, because it needs to keep the
+ * when application calls #pjsip_tsx_send_msg, because it needs to keep the
  * message for retransmission. The transaction will release the reference
  * counter once its state has reached final state.
Index: pjproject/trunk/pjsip/include/pjsip/sip_util.h
===================================================================
--- pjproject/trunk/pjsip/include/pjsip/sip_util.h	(revision 735)
+++ pjproject/trunk/pjsip/include/pjsip/sip_util.h	(revision 736)
@@ -396,5 +396,5 @@
  * This is an auxiliary function to be used by application to send arbitrary
  * requests outside a dialog. To send a request within a dialog, application
- * should use #pjsip_dlg_send_msg instead.
+ * should use #pjsip_dlg_send_request instead.
  *
  * @param endpt	    The endpoint instance.